//+------------------------------------------------------------------+
//|                                                        SR-EA.mq4 |
//|                                         Copyright 2013, bachapk. |
//|                                         Email: bachapk@gmail.com |
//|                                              Skype: bacha.rehman |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Bacha Rehman, Copyright 2013"
#property link      "bachapk@gmail.com"

#include <stderror.mqh>

extern string EAName                        = "SR EA";
extern string _1___________________________ = "___Select Pips and Seconds for Strategy___";
extern bool   Trade                         = true; // True if this EA will place trades, False if this EA will only manage trades
extern bool   CloseAll                      = false; // If CloseAll then EA will close all trades
extern bool   AlertsOn                      = false; // Alerts on Opening and closing orders
extern bool   PlaceSecondOrder              = true; // Do You want to place 2nd order?
extern double NumberOfPipsInProfit          = 40; // How many pips in profit for placing 2nd order

extern string  _2___________________________ = "___Money & Risk Management___";
extern double Lots                           = 0.1; // Lot Size
extern bool   UseAutoLots                    = false; // if you want to use auto money management instead of fixed lot size then make it true
extern double Risk                           = 2; // if auto money management then enter your risk value here
extern double TakeProfit                     = 50; // In Pips. Take Profit
extern int    Slippage                       = 3; // In Pips. Slippage 
extern double Spread                         = 5; // Spread in pips
extern bool   StoplossBelowAboveSR           = true; // Set stop loss above or below Previous SR Line
extern double PipsBelowAbove                 = 0; // How many pips above or below Previous SR Line?
extern double StopLoss                       = 100; // In Pips. Initial Stop Loss 

extern string _3___________________________  = "___Orders Settings__";
extern double MagicNumber                    = 998; // Do not change this Magic Number. Magic Number will be different for all time frames
extern int    NumberOfOrders                 = 1; // Number of maximum orders at a time 

extern string _4___________________________  = "___Break Even and Partial TP settings__";
extern bool   UseBreakEven                   = false; // If you want to use Break Even then make it true
extern double BEPoint                        = 30; //Pips in profit on which a Break Even will be set
extern double BEPips                         = 10; // StopLoss will be move +BEPips when BEPoint reached
extern bool   UseTrailingStop                = false; // Make it true if you want trailing stop
extern double TrailingStop                   = 10;  // Profit Pips where the trailing stop will move the stoploss with trailing step
extern double TrailingStep                   = 10;  // Number of Pips for moving stop loss in profit at one time

extern string _5___________________________  = "___Prints Comments on the Screen__";
extern bool   PrintCommentsOnScreen          = true; // Make it false if you do not want screen comments
extern string TradeComments                  = "SR EA"; 

extern string _6___________________________  = "___Time Settings__";
extern bool   UseTime                        = false; // Do you want to open trades between specific time intervals? if yes make it true
extern string StartTime                      = "07:00"; //Broker Time - Entry Time
extern string EndTime                        = "17:00"; // Broker Time

extern string _7___________________________  = "___Indicators Setup__";
extern string MySRIndName                    = "mySR"; // Trend Master Indicator Name
extern int    barn                           = 1300;
extern int    Length                         = 4;
extern int    CandleTF                       = 240;
extern bool   SRAlertOn                      = false;
extern bool   SREmailOn                      = false;

extern string _8___________________________ = "Order Closing Settings";
extern bool   CloseOnOppositeSignal          = true; // Do you want to close orders on Opposite Signal? If yes then make it true


bool BE;
datetime CurrentOrderTime;
string CurrentOrderComments="";
double CurrentOrderProfitLoss, CurrentOrderOpenPrice, CurrentOrderTP, CurrentOrderSL;

// Timeout 10 seconds
int Timeout = 10000;

double BRatio;
// Number of retries upon failure
int Retries = 10;

// Current symbol to use if different from Chart
string CurrentSymbol = "";
string EAComment="";
// Current number of Digits
int CurrentDigits = 5;

// Current Points
double CurrentPoints = 0.0001;

bool NewBar,SpreadCheck;
datetime BarTime;
bool AllowTrade=true;
bool SRBuySignal, SRSellSignal;
int Buys,Sells;
double LotSize,CurSpread,spread;
int lot;
double SRBuy, SRSell, SRBuy2, SRSell2;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
LotSize=Lots;
RefreshRates();

EAComment=EAName+", "+Symbol()+" "+Period(); 
BarTime=Time[0];
BE=true;

// If no symbol set use current chart
if(StringLen(CurrentSymbol) == 0)
CurrentSymbol = Symbol();

CurrentPoints = MarketInfo(CurrentSymbol, MODE_POINT);
CurrentDigits = MarketInfo(CurrentSymbol, MODE_DIGITS);

// Check the digits and points
if(CurrentDigits == 3 || CurrentDigits==5)
{
CurrentPoints = CurrentPoints*10;
Slippage=Slippage*10;
}
spread=NormalizeDouble(Spread*CurrentPoints,Digits);
switch (MarketInfo(Symbol(), MODE_MINLOT)) {
   case 0.001:
      lot = 3;
      break;
   case 0.01:
      lot = 2;
      break;
   case 0.1:
      lot = 1;
      break;
   case 1.0:
      lot = 0;
   }
return(0);
}

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//----
   if (ObjectFind("BKGR") >= 0) ObjectDelete("BKGR");
   if (ObjectFind("BKGR2") >= 0) ObjectDelete("BKGR2");
   if (ObjectFind("BKGR3") >= 0) ObjectDelete("BKGR3");
   if (ObjectFind("BKGR4") >= 0) ObjectDelete("BKGR4");
   if (ObjectFind("LV") >= 0) ObjectDelete("LV");
//----
   return(0);
}

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
bool TradeTime=true;
SRSellSignal = false;
SRBuySignal = false;


NewBar=isNewBar();
if(DayOfWeek()==0 || DayOfWeek()==6) return(0);

if ((!IsTesting()) && IsStopped() && GetLastError()>1) { Print(TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS)+" | "+EAComment+" | "+ErrorDescription(GetLastError())+GetLastError()); return (0); }
if ((!IsTesting()) && !IsTradeAllowed() && GetLastError()>1) { Print(TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS)+" | "+EAComment+" | "+ErrorDescription(GetLastError())+GetLastError()); return (0); }
if ((!IsTesting()) && IsTradeContextBusy() && GetLastError()>1) { Print(TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS)+" | "+EAComment+" | "+ErrorDescription(GetLastError())+GetLastError()); return (0); }

if (UseTime == true)
TradeTime = TimeCurrent()>StrToTime(TimeToStr(TimeCurrent(),TIME_DATE)+" "+StartTime) && TimeCurrent()<StrToTime(TimeToStr(TimeCurrent(),TIME_DATE)+" "+EndTime);

SRBuy = iCustom(NULL,0,MySRIndName, barn, Length, CandleTF, SRAlertOn, SREmailOn,0,1);
SRSell = iCustom(NULL,0,MySRIndName, barn, Length, CandleTF, SRAlertOn, SREmailOn,1,1);
SRBuy2 = iCustom(NULL,0,MySRIndName, barn, Length, CandleTF, SRAlertOn, SREmailOn,0,2);
SRSell2 = iCustom(NULL,0,MySRIndName, barn, Length, CandleTF, SRAlertOn, SREmailOn,1,2);

if(SRBuy2==0 && SRBuy!=0)
SRBuySignal=true;
else if(SRSell2==0 && SRSell!=0)
SRSellSignal=true;
//Print (SRBuy,"   ",SRBuy2,"   ", SRSell,"   ",SRSell2);
CurSpread=NormalizeDouble(MathAbs(Ask-Bid),Digits);
SpreadCheck=CurSpread<=spread;

Buys=IsExecuted(OP_BUY);
Sells=IsExecuted(OP_SELL);
  
  if ((Buys+Sells<NumberOfOrders) && TradeTime && SpreadCheck && Trade)
  {   
      if (AllowTrade)
      {
      if (SRBuySignal==true)
      {
      NewStopOrder(OP_BUY); OrderUpdate();
      AllowTrade=false;
      if(AlertsOn==true)
      Alert("Buy Order Placed at ",DoubleToStr(Ask, Digits)," in Currency Pair ",Symbol());
      }
      else if(SRSellSignal==true)
      {
      NewStopOrder(OP_SELL); OrderUpdate();
      AllowTrade=false;
      if(AlertsOn==true)
      Alert("Sell Order Placed at ",DoubleToStr(Bid, Digits)," in Currency Pair ",Symbol());
      }
      }
  }
  else if (PlaceSecondOrder && (Buys+Sells<2) && TradeTime && SpreadCheck && Trade) {
      int j;
      bool PlaceTrade=false;
      for (j = OrdersTotal() - 1; j >= 0; j--) {
      OrderSelect(j, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == CurrentSymbol && OrderMagicNumber()==MagicNumber) { 
      if (OrderType()==OP_BUY && Ask-OrderOpenPrice()>NormalizeDouble(NumberOfPipsInProfit*CurrentPoints,Digits))
      PlaceTrade=true;
      else if (OrderType()==OP_SELL && OrderOpenPrice()-Bid>NormalizeDouble(NumberOfPipsInProfit*CurrentPoints,Digits))
      PlaceTrade=true;
      }}
      
      if (AllowTrade)
      {
      if (Buys==1 && PlaceTrade)
      {
      NewStopOrder(OP_BUY); OrderUpdate();
      AllowTrade=false;
      if(AlertsOn==true)
      Alert("2nd Buy Order Placed at ",DoubleToStr(Ask, Digits)," in Currency Pair ",Symbol());
      }
      else if(Sells==1 && PlaceTrade)
      {
      NewStopOrder(OP_SELL); OrderUpdate();
      AllowTrade=false;
      if(AlertsOn==true)
      Alert("2nd Sell Order Placed at ",DoubleToStr(Bid, Digits)," in Currency Pair ",Symbol());
      }
      }
  
  }
  
  
  
  
  OrderUpdate();
  

if (PrintCommentsOnScreen) ShowComments();
return(0);
}


//+--------------------------------------------------------------------------------------------------------------+
//| GetInitialLots. Function to get automatic lot size according to available balance and Risk Value
//+--------------------------------------------------------------------------------------------------------------+
double GetInitialLots() {
    double Lot=NormalizeDouble( (AccountBalance() * Risk ) / (1000 * StopLoss) , lot);
    return (Lot);
}

//+--------------------------------------------------------------------------------------------------------------+
//| CheckBreakEven. Function to Check the Break Even Conditions 
//+--------------------------------------------------------------------------------------------------------------+
void CheckBreakEven() 
{
//----
   RefreshRates();
   double ask = NormalizeDouble(MarketInfo(CurrentSymbol, MODE_ASK), CurrentDigits);
   double bid = NormalizeDouble(MarketInfo(CurrentSymbol, MODE_BID), CurrentDigits);
   bool result;
   if (OrderType()==OP_BUY && OrderStopLoss()!=NormalizeDouble(OrderOpenPrice()+BEPips*CurrentPoints,Digits)) 
   {
      if ((OrderStopLoss()==0 || OrderStopLoss()<OrderOpenPrice()) && (bid>=OrderOpenPrice()+BEPoint*CurrentPoints)) 
      { 
      result=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()+BEPips*CurrentPoints,Digits),OrderTakeProfit(),0,CLR_NONE);
      if (!result && GetLastError()>1 ) Print(TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS)+" | "+ErrorDescription(GetLastError())+GetLastError());
      
      }
   }          

   else if (OrderType()==OP_SELL && OrderStopLoss()!=NormalizeDouble(OrderOpenPrice()-BEPips*CurrentPoints,Digits)) 
   {
      if ((OrderStopLoss()==0 || OrderStopLoss()>OrderOpenPrice()) && (ask<=OrderOpenPrice()-BEPoint*CurrentPoints)) 
      {
      result=OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()-BEPips*CurrentPoints,Digits),OrderTakeProfit(),0,CLR_NONE);
      if (!result && GetLastError()>1) Print(TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS)+" | "+ErrorDescription(GetLastError())+GetLastError());
      
      }
   }
   
   

} 

//+--------------------------------------------------------------------------------------------------------------+
//| CheckTrailingStop. Function to Check the Trailing Stop Conditions
//+--------------------------------------------------------------------------------------------------------------+
void CheckTrailingStop() {
//----

   if ((OrderType()==OP_BUY) && (Bid>=OrderOpenPrice()+TrailingStop*CurrentPoints)) {
      if ((OrderStopLoss()==0) || (OrderStopLoss()<Bid-TrailingStop*CurrentPoints-TrailingStep*CurrentPoints))    
         OrderModify(OrderTicket(),OrderOpenPrice(),Bid-TrailingStop*CurrentPoints,OrderTakeProfit(),0,Lime);
   } 

   else if ((OrderType()==OP_SELL) && (Ask<=OrderOpenPrice()-TrailingStop*CurrentPoints)) {
      if ((OrderStopLoss()==0) || (OrderStopLoss()>Ask+TrailingStop*CurrentPoints+TrailingStep*CurrentPoints)) 
         OrderModify(OrderTicket(),OrderOpenPrice(),Ask+TrailingStop*CurrentPoints,OrderTakeProfit(),0,Red);
   }
   
} 

//+--------------------------------------------------------------------------------------------------------------+
//| NewStopOrder. Function to Place New Orders
//+--------------------------------------------------------------------------------------------------------------+
void NewStopOrder(int orderType)
{
BE=true;
AllowTrade=false;
bool loop = True;
int count = 0;
if (UseAutoLots) 
{ 
LotSize = GetInitialLots(); 
if (LotSize<MarketInfo(Symbol(), MODE_MINLOT)) LotSize = NormalizeDouble( MarketInfo(Symbol(), MODE_MINLOT), lot);
}
else LotSize=Lots;


while (loop && count < Retries)
{
while (IsTradeContextBusy())
{
Sleep(Timeout);
count++;
}
RefreshRates();
double ask = NormalizeDouble(MarketInfo(CurrentSymbol, MODE_ASK), CurrentDigits);
double bid = NormalizeDouble(MarketInfo(CurrentSymbol, MODE_BID), CurrentDigits);
switch(orderType)
{
case OP_BUY:
OrderSend(CurrentSymbol, OP_BUY, LotSize, ask, Slippage, 0, 0, TradeComments, MagicNumber, 0, Green);
break;
case OP_SELL:
OrderSend(CurrentSymbol, OP_SELL, LotSize, bid, Slippage, 0, 0, TradeComments, MagicNumber, 0, Red);
break;
}
loop = parseError();
}
}


//+--------------------------------------------------------------------------------------------------------------+
//| OrderUpdate. Function to Modify Orders, Set TPs and Sl, Check Traling Stop and Break Even Conditions
//+--------------------------------------------------------------------------------------------------------------+
void OrderUpdate()
{
double OrderTP, OrderSL,SL;
bool BuyTP,BuySL, SellTP, SellSL;
bool result;
bool UpdateSLTP=false;
for (int i = OrdersTotal() - 1; i >= 0; i--)
{
OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
if (OrderSymbol() == CurrentSymbol )
   {  

   if (OrderType()==OP_BUY && NormalizeDouble(TakeProfit,0)!=NormalizeDouble((OrderTakeProfit()-OrderOpenPrice())/CurrentPoints,0))
   UpdateSLTP=true;
   if (OrderType()==OP_SELL && NormalizeDouble(TakeProfit,0)!=NormalizeDouble((OrderOpenPrice()-OrderTakeProfit())/CurrentPoints,0))
   UpdateSLTP=true;
     
      if (OrderStopLoss()==0 || UpdateSLTP)
      {  
          RefreshRates();
         double tp = NormalizeDouble(TakeProfit*CurrentPoints,Digits);
         double sl = NormalizeDouble(StopLoss*CurrentPoints,Digits);
         
         
            
         switch(OrderType())
         {
            case OP_SELL:
            if (StoplossBelowAboveSR==false)
            { OrderSL=OrderOpenPrice()+sl; }
            else
            { OrderSL=NormalizeDouble(SRSell+PipsBelowAbove*CurrentPoints,Digits); }
            OrderTP=OrderOpenPrice()-tp;
            break;
            case OP_BUY:
            if (StoplossBelowAboveSR==false)
            { OrderSL=OrderOpenPrice()-sl; }
            else
            { OrderSL=NormalizeDouble(SRBuy-PipsBelowAbove*CurrentPoints,Digits);  }
            OrderTP=OrderOpenPrice()+tp;
            break;
         }
         
         if (TakeProfit==0) OrderTP=0;
         if (StopLoss==0) OrderSL=0;
         result=OrderModify(OrderTicket(),OrderOpenPrice(), OrderSL, OrderTP, 0, CLR_NONE);
         if (!result && GetLastError()>1)Print(TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS)+" | "+EAComment+" | "+ErrorDescription(GetLastError())+GetLastError());
       }
       
       
       if (UseBreakEven)
       CheckBreakEven();
       
       if (UseTrailingStop)
       CheckTrailingStop();
       
       if (CloseOnOppositeSignal) {
       switch(OrderType())
         {
            case OP_SELL:
            if(SRBuySignal==true) {
            result=OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Red);
            if (!result && GetLastError()>1)Print(TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS)+" | "+EAComment+" | "+ErrorDescription(GetLastError())+GetLastError());
            }
            break;
            case OP_BUY:
            if(SRSellSignal) {
            result=OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,MediumSeaGreen);
            if (!result && GetLastError()>1)Print(TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS)+" | "+EAComment+" | "+ErrorDescription(GetLastError())+GetLastError());
            }
            break;
         }
       
       
       
       }
       
       if (CloseAll)
       CloseThisSymbolAll(OrderType());
           
                   
      }
   }

}

//+--------------------------------------------------------------------------------------------------------------+
//| Check if The Order is Executed or Not
//+--------------------------------------------------------------------------------------------------------------+
int IsExecuted(int orderType)
{
int count = 0;
for (int i = 0; i < OrdersTotal(); i++)
{
OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
if (OrderSymbol() == CurrentSymbol && OrderMagicNumber()==MagicNumber)
{
if (OrderType() == orderType )
{

if(orderType==OP_BUY) {
CurrentOrderProfitLoss=(Bid-OrderOpenPrice())/CurrentPoints;
CurrentOrderTime=OrderOpenTime();
CurrentOrderOpenPrice=OrderOpenPrice();
CurrentOrderComments=OrderComment();
CurrentOrderTP=(OrderTakeProfit()-OrderOpenPrice())/CurrentPoints;
CurrentOrderSL=(OrderOpenPrice()-OrderStopLoss())/CurrentPoints;
}
else if (orderType==OP_SELL) {
CurrentOrderProfitLoss= (OrderOpenPrice()-Ask)/CurrentPoints;
CurrentOrderTime=OrderOpenTime();
CurrentOrderOpenPrice=OrderOpenPrice();
CurrentOrderComments=OrderComment();
CurrentOrderTP=(OrderOpenPrice()-OrderTakeProfit())/CurrentPoints;
CurrentOrderSL=(OrderStopLoss()-OrderOpenPrice())/CurrentPoints;
}
count++;
}
}
}
return (count);
}

//+--------------------------------------------------------------------------------------------------------------+
//| ShowComments. Function to Show comments to User
//+--------------------------------------------------------------------------------------------------------------+
void ShowComments() {
//+--------------------------------------------------------------------------------------------------------------+
int stp, ssl;
//stp=TakeProfit; ssl=StopLoss;
string ComSpacer = ""; //--- "/n"
datetime MyOpDate = TIME_DATE; //--- 
//---
ComSpacer = ComSpacer
      + "\n  " 
      + "\n "
      //+ "\nEA By Bacha"
      + "\nCopyright  Bacha"
      //+ "\nhttps://login.mql5.com/en/users/bachapk"
      + "\n-----------------------------------------------"
      + "\nEA Attached to : " + Symbol() +Period()
      //+ "\n  Optimization date: " + TimeToStr (Date, MyOpDate)
      + "\n-----------------------------------------------" 
      + "\nSL = " + DoubleToStr(CurrentOrderSL,0) + " pips / TP = " + DoubleToStr(CurrentOrderTP,0) + " pips" ;
   
      //ComSpacer = ComSpacer 
      //+ "\n-----------------------------------------------"
      //ComSpacer = ComSpacer 
      //+ "\nTrading Lots = " + DoubleToStr(Lots, 2);
   
      ComSpacer = ComSpacer 
      + "\n-----------------------------------------------"
      +"\nCurrrent Date: " 
      + TimeToStr (TimeCurrent());
      
      ComSpacer = ComSpacer 
      + "\n-----------------------------------------------"
      +"\nTrade Comments : " 
      + CurrentOrderComments;
      
      ComSpacer = ComSpacer 
      + "\n-----------------------------------------------"
      +"\nTrade Open Price : " 
      + DoubleToStr(CurrentOrderOpenPrice,CurrentDigits);
      
      ComSpacer = ComSpacer 
      + "\n-----------------------------------------------"
      +"\nTrade Open Time : " 
      + TimeToStr(CurrentOrderTime);
      
      ComSpacer = ComSpacer 
      + "\n-----------------------------------------------"
      +"\nCurrent Order Profit/Loss (Pips): " 
      + DoubleToStr(CurrentOrderProfitLoss,1);

      ComSpacer = ComSpacer 
      + "\n-----------------------------------------------";
      Comment(ComSpacer);
   
   if (ObjectFind("LV") < 0) {
      ObjectCreate("LV", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("LV", "SR EA", 9, "Tahoma Bold", White);
      ObjectSet("LV", OBJPROP_CORNER, 0);
      ObjectSet("LV", OBJPROP_BACK, FALSE);
      ObjectSet("LV", OBJPROP_XDISTANCE, 13);
      ObjectSet("LV", OBJPROP_YDISTANCE, 23);
   }
   if (ObjectFind("BKGR") < 0) {
      ObjectCreate("BKGR", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("BKGR", "g", 110, "Webdings", DarkViolet 	);
      ObjectSet("BKGR", OBJPROP_CORNER, 0);
      ObjectSet("BKGR", OBJPROP_BACK, TRUE);
      ObjectSet("BKGR", OBJPROP_XDISTANCE, 5);
      ObjectSet("BKGR", OBJPROP_YDISTANCE, 15);
   }
   if (ObjectFind("BKGR2") < 0) {
      ObjectCreate("BKGR2", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("BKGR2", "g", 110, "Webdings", MidnightBlue);
      ObjectSet("BKGR2", OBJPROP_BACK, TRUE);
      ObjectSet("BKGR2", OBJPROP_XDISTANCE, 5);
      ObjectSet("BKGR2", OBJPROP_YDISTANCE, 60);
   }
   if (ObjectFind("BKGR3") < 0) {
      ObjectCreate("BKGR3", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("BKGR3", "g", 110, "Webdings", MidnightBlue);
      ObjectSet("BKGR3", OBJPROP_CORNER, 0);
      ObjectSet("BKGR3", OBJPROP_BACK, TRUE);
      ObjectSet("BKGR3", OBJPROP_XDISTANCE, 5);
      ObjectSet("BKGR3", OBJPROP_YDISTANCE, 45);
   }
   if (ObjectFind("BKGR4") < 0) {
      ObjectCreate("BKGR4", OBJ_LABEL, 0, 0, 0);
      ObjectSetText("BKGR4", "g", 110, "Webdings", MidnightBlue);
      ObjectSet("BKGR4", OBJPROP_CORNER, 0);
      ObjectSet("BKGR4", OBJPROP_BACK, TRUE);
      ObjectSet("BKGR4", OBJPROP_XDISTANCE, 5);
      ObjectSet("BKGR4", OBJPROP_YDISTANCE, 84);
   }
}   

//+--------------------------------------------------------------------------------------------------------------+
//| ErrorDescription. 
//+--------------------------------------------------------------------------------------------------------------+
string ErrorDescription(int error) {
//+--------------------------------------------------------------------------------------------------------------+

   string ErrorNumber;
   //---
   switch (error) {
   case 0:
   case 1:     ErrorNumber = "No error returned, but the result is unknown";        break;
   case 2:     ErrorNumber = "Common error";                                        break;
   case 3:     ErrorNumber = "Invalid trade parameters";                            break;
   case 4:     ErrorNumber = "Trade server is busy";                                break;
   case 5:     ErrorNumber = "Old version of the client terminal";                  break;
   case 6:     ErrorNumber = "No connection with trade server";                     break;
   case 7:     ErrorNumber = "Not enough rights";                                   break;
   case 8:     ErrorNumber = "Too frequent requests";                               break;
   case 9:     ErrorNumber = "Malfunctional trade operation";                       break;
   case 64:    ErrorNumber = "Account disabled";                                    break;
   case 65:    ErrorNumber = "Invalid account";                                     break;
   case 128:   ErrorNumber = "Trade timeout";                                       break;
   case 129:   ErrorNumber = "Invalid price";                                       break;
   case 130:   ErrorNumber = "Invalid stops";                                       break;
   case 131:   ErrorNumber = "Invalid trade volume";                                break;
   case 132:   ErrorNumber = "Market is closed";                                    break;
   case 133:   ErrorNumber = "Trade is disabled";                                   break;
   case 134:   ErrorNumber = "Not enough money";                                    break;
   case 135:   ErrorNumber = "Price changed";                                       break;
   case 136:   ErrorNumber = "Off quotes";                                          break;
   case 137:   ErrorNumber = "Broker is busy";                                      break;
   case 138:   ErrorNumber = "Requote";                                             break;
   case 139:   ErrorNumber = "Order is locked";                                     break;
   case 140:   ErrorNumber = "Long positions only allowed";                         break;
   case 141:   ErrorNumber = "Too many requests";                                   break;
   case 145:   ErrorNumber = "Modification denied because order too close to market";break;
   case 146:   ErrorNumber = "Trade context is busy";                                break;
   case 147:   ErrorNumber = "Expirations are denied by broker";                    break;
   case 148:   ErrorNumber = "The amount of open and pending orders has reached the limit set by the broker"; break;
   //---- 
   case 4000:  ErrorNumber = "No error";                                            break;
   case 4001:  ErrorNumber = "Wrong function pointer";                              break;
   case 4002:  ErrorNumber = "Array index is out of range";                         break;
   case 4003:  ErrorNumber = "No memory for function call stack";                   break;
   case 4004:  ErrorNumber = "Recursive stack overflow";                            break;
   case 4005:  ErrorNumber = "Not enough stack for parameter";                      break;
   case 4006:  ErrorNumber = "No memory for parameter string";                      break;
   case 4007:  ErrorNumber = "No memory for temp string";                           break;
   case 4008:  ErrorNumber = "Not initialized string";                              break;
   case 4009:  ErrorNumber = "Not initialized string in array";                     break;
   case 4010:  ErrorNumber = "No memory for array string";                          break;
   case 4011:  ErrorNumber = "Too long string";                                     break;
   case 4012:  ErrorNumber = "Remainder from zero divide";                          break;
   case 4013:  ErrorNumber = "Zero divide";                                         break;
   case 4014:  ErrorNumber = "Unknown command";                                     break;
   case 4015:  ErrorNumber = "Wrong jump (never generated error)";                  break;
   case 4016:  ErrorNumber = "Not initialized array";                               break;
   case 4017:  ErrorNumber = "DLL calls are not allowed";                           break;
   case 4018:  ErrorNumber = "Cannot load library";                                 break;
   case 4019:  ErrorNumber = "Cannot call function";                                break;
   case 4020:  ErrorNumber = "Expert function calls are not allowed";               break;
   case 4021:  ErrorNumber = "Not enough memory for temp string returned from function";    break;
   case 4022:  ErrorNumber = "System is busy (never generated error)";              break;
   case 4050:  ErrorNumber = "Invalid function parameters count";                   break;
   case 4051:  ErrorNumber = "Invalid function parameter value";                    break;
   case 4052:  ErrorNumber = "String function internal error";                      break;
   case 4053:  ErrorNumber = "Some array error";                                    break;
   case 4054:  ErrorNumber = "Incorrect series array using";                        break;
   case 4055:  ErrorNumber = "Custom indicator error";                              break;
   case 4056:  ErrorNumber = "Arrays are incompatible";                             break;
   case 4057:  ErrorNumber = "Global variables processing error";                   break;
   case 4058:  ErrorNumber = "Global variable not found";                           break;
   case 4059:  ErrorNumber = "Function is not allowed in testing mode";             break;
   case 4060:  ErrorNumber = "Function is not confirmed";                           break;
   case 4061:  ErrorNumber = "Send mail error";                                     break;
   case 4062:  ErrorNumber = "String parameter expected";                           break;
   case 4063:  ErrorNumber = "Integer parameter expected";                          break;
   case 4064:  ErrorNumber = "Double parameter expected";                           break;
   case 4065:  ErrorNumber = "Array as parameter expected";                         break;
   case 4066:  ErrorNumber = "Requested history data in updating state";            break;
   case 4067:  ErrorNumber = "Some error in trading function";                      break;
   case 4099:  ErrorNumber = "End of file";                                         break;
   case 4100:  ErrorNumber = "Some file error";                                     break;
   case 4101:  ErrorNumber = "Wrong file name";                                     break;
   case 4102:  ErrorNumber = "Too many opened files";                               break;
   case 4103:  ErrorNumber = "Cannot open file";                                    break;
   case 4104:  ErrorNumber = "Incompatible access to a file";                       break;
   case 4105:  ErrorNumber = "No order selected";                                   break;
   case 4106:  ErrorNumber = "Unknown symbol";                                      break;
   case 4107:  ErrorNumber = "Invalid price";                                       break;
   case 4108:  ErrorNumber = "Invalid ticket";                                      break;
   case 4109:  ErrorNumber = "Trade is not allowed. Enable checkbox Allow live trading in the expert properties";                                      break;
   case 4110:  ErrorNumber = "Longs are not allowed. Check the expert properties";  break;
   case 4111:  ErrorNumber = "Shorts are not allowed. Check the expert properties"; break;
   case 4200:  ErrorNumber = "Object exists already";                               break;
   case 4201:  ErrorNumber = "Unknown object property";                             break;
   case 4202:  ErrorNumber = "Object does not exist";                               break;
   case 4203:  ErrorNumber = "Unknown object type";                                 break;
   case 4204:  ErrorNumber = "No object name";                                      break;
   case 4205:  ErrorNumber = "Object coordinates error";                            break;
   case 4206:  ErrorNumber = "No specified subwindow";                              break;
   case 4207:  ErrorNumber = "Some error in object function";                       break;
   default:    ErrorNumber = "Unknown error";
   }
   //---
   return (ErrorNumber);
}

//+--------------------------------------------------------------------------------------------------------------+
//| ShowErrors. Function to Show Errors to User
//+--------------------------------------------------------------------------------------------------------------+
bool parseError()
{
bool buffer = false;
int Err = GetLastError();
switch (Err)
{
case ERR_NO_ERROR:
buffer = false;
break;
case ERR_SERVER_BUSY:
case ERR_NO_CONNECTION:
case ERR_INVALID_PRICE:
case ERR_OFF_QUOTES:
case ERR_BROKER_BUSY:
case ERR_TRADE_CONTEXT_BUSY:
case ERR_PRICE_CHANGED:
case ERR_REQUOTE:
buffer = true;
break;
case ERR_INVALID_STOPS:
buffer = false;
Print("Invalid Stops");
break;
case ERR_INVALID_TRADE_VOLUME:
buffer = false;
Print("Invalid Lots");
break;
case ERR_MARKET_CLOSED:
buffer = false;
Print("Market Close");
break;
case ERR_TRADE_DISABLED:
buffer = false;
Print("Trades Disabled");
break;
case ERR_NOT_ENOUGH_MONEY:
buffer = false;
Print("Not Enough Money");
break;
case ERR_TRADE_TOO_MANY_ORDERS:
buffer = false;
Print("Too Many Orders");
break;
case ERR_NO_RESULT:
default:
if(Err > 1)
Print("Unknown Error ", Err);
else
buffer = false;
break;
}
return (buffer);
}

bool isNewBar() {
//---- 
   bool res=false; 
   if (BarTime!=Time[0]) {
      BarTime=Time[0];  
      res=true; AllowTrade=true;
   } 
//----    
   return(res);   
}

void CloseThisSymbolAll(int OrdType) {
   for (int l_pos_0 = OrdersTotal() - 1; l_pos_0 >= 0; l_pos_0--) {
      OrderSelect(l_pos_0, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol()) {
         if (OrderSymbol() == Symbol() && OrderType()==OrdType) {
            if (OrderType() == OP_BUY) OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, Blue);
            if (OrderType() == OP_SELL) OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, Red);
         }
         Sleep(1000);
      }
   }
}